"use strict";

require("core-js/modules/es6.function.name");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.array.filter");

var _core = require("@babel/core");

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _package = require("../../package.json");

var _handler = _interopRequireDefault(require("./handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @example
 * new WriteFiles()
 */
var WriteFiles = function WriteFiles() {
  var _this = this;

  _classCallCheck(this, WriteFiles);

  this.store = [];
  this.isWritting = false;

  this.add = function (file) {
    _this.store.push(file);

    if (!_this.isWritting) _this.writeFiles();
  };

  this.writeFiles = function () {
    _this.isWritting = true;
    var _handler$options = _handler["default"].options,
        verbose = _handler$options.verbose,
        watch = _handler$options.watch;

    var _this$store$pop = _this.store.pop(),
        srcPath = _this$store$pop.srcPath,
        destPath = _this$store$pop.destPath,
        babelConfig = _this$store$pop.babelConfig;

    var _console = console,
        log = _console.log;

    try {
      var _transformFileSync = (0, _core.transformFileSync)(srcPath, _objectSpread({}, babelConfig, {
        babelrc: false,
        configFile: false
      })),
          code = _transformFileSync.code;

      _this.store = _this.store.filter(function (writeFile) {
        return writeFile.srcPath !== srcPath;
      });
      (0, _outputFileSync["default"])(destPath, code.replace(/fixme-flow-file-annotation/, '@flow'));
      _this.isWritting = false;
      if (verbose) log("".concat(srcPath, " -> ").concat(destPath));
      if (_this.store.length !== 0) _this.writeFiles();
    } catch (e) {
      var errorMessage = "".concat(_package.name, " ").concat(e);
      _this.isWritting = false;
      if (watch) log(errorMessage);else throw new Error(errorMessage);
    }
  };
};

var _default = new WriteFiles();

exports["default"] = _default;
module.exports = exports.default;